
#include "starlab_vector.h"

// Implement and test the (fourth-order accurate) expansion of the 
// force due to a binary.

main()
{
    real d = 0.001;
    real D = 1.0;

    srandinter(0);

    real m1 = randinter(0,1);
    real m2 = randinter(0,1);
    real m3 = randinter(0,1);

    PRC(m1); PRC(m2); PRL(m3);

    real theta = M_PI * randinter(0, 1);
    real phi = 2*M_PI * randinter(0, 1);
    real psi = 2*M_PI * randinter(0, 1);

    PRC(theta); PRC(phi); PRL(psi);

    real M = m1 + m2;
    real mu = m1*m2/M;

    vector r1 = d * m2 * vector(cos(psi), sin(psi), 0) / M;
    vector r2 = -m1 * r1 / m2;
    vector r3 = D * vector(sin(theta)*cos(phi), sin(theta)*sin(phi),
			   cos(theta));

    // Exact calculation:

    vector r13 = r3 - r1;
    vector r23 = r3 - r2;
    vector r = r2 - r1;
    vector r3hat = r3/abs(r3);

    vector f13 = m1*m3*r13*pow(square(r13), -1.5);
    vector f23 = m2*m3*r23*pow(square(r23), -1.5);

    vector ftot_true = f13 + f23;

    // Approximate calculation (4th order error):

    vector ftot_app = M*m3*r3 / pow(D, 3)
		      + 1.5*mu*m3*r3*(5*square(r*r3hat)-r*r) / pow(D, 5)
		      - 3*mu*m3*(r*r3hat)*r / pow(D, 4);

    vector error = ftot_app - ftot_true;

    PRL(ftot);
    PRL(ftot_app);
    PRL(error);
}
