
#ifdef HAS_PVM

#include "scatter3.h"
#include "pvm3.h"

// Pack and unpack scattering structures (overloaded!).

void pack(initial_state3 &init)
{
    pvm_pkdouble(&init.m2, 1, 1);
    pvm_pkdouble(&init.m2, 1, 1);
    pvm_pkdouble(&init.m3, 1, 1);
    pvm_pkdouble(&init.r1, 1, 1);
    pvm_pkdouble(&init.r2, 1, 1);
    pvm_pkdouble(&init.r3, 1, 1);
    pvm_pkdouble(&init.sma, 1, 1);
    pvm_pkdouble(&init.ecc, 1, 1);
    pvm_pkdouble(&init.v_inf, 1, 1);
    pvm_pkdouble(&init.rho, 1, 1);
    pvm_pkdouble(&init.r_init_min, 1, 1);
    pvm_pkdouble(&init.r_init_max, 1, 1);
    pvm_pkdouble(&init.r_init, 1, 1);
    pvm_pkdouble(&init.r_stop, 1, 1);
    pvm_pkdouble(&init.tidal_tol_factor, 1, 1);
    pvm_pkdouble(&init.phase.cos_theta, 1, 1);
    pvm_pkdouble(&init.phase.phi, 1, 1);
    pvm_pkdouble(&init.phase.psi, 1, 1);
    pvm_pkdouble(&init.phase.mean_anomaly, 1, 1);
    pvm_pkdouble(&init.eta, 1, 1);
    for (int i = 0; i < 3; i++) {
	pvm_pkdouble(&init.system[i].mass, 1, 1);
	pvm_pkdouble(init.system[i].pos, 3, 1);
	pvm_pkdouble(init.system[i].vel, 3, 1);
	pvm_pkint(&init.system[i].index, 1, 1);
    }
}

void pack(intermediate_state3 &inter)
{
    pvm_pkint(&inter.n_osc, 1, 1);
    pvm_pkint(&inter.n_kepler, 1, 1);
    pvm_pkint(&inter.n_stars, 1, 1);
    pvm_pkint(inter.index, 3, 1);
    pvm_pkdouble(inter.r_min, 3, 1);
    pvm_pkdouble(&inter.r_min_min, 1,1);
    int i = (int)inter.descriptor;
    pvm_pkint(&i, 1, 1);
    for (i = 0; i < 3; i++) {
	pvm_pkdouble(&inter.system[i].mass, 1, 1);
	pvm_pkdouble(inter.system[i].pos, 3, 1);
	pvm_pkdouble(inter.system[i].vel, 3, 1);
	pvm_pkint(&inter.system[i].index, 1, 1);
    }
}

void pack(final_state3 &final)
{
    pvm_pkdouble(&final.sma, 1, 1);
    pvm_pkdouble(&final.ecc, 1, 1);
    pvm_pkdouble(&final.outer_separation, 1, 1);
    int i = (int)final.descriptor;
    pvm_pkint(&i, 1, 1);
    pvm_pkint(&final.escaper, 1, 1);
    pvm_pkdouble(&final.error, 1, 1);
    pvm_pkdouble(&final.time, 1, 1);
    pvm_pkint(&final.n_steps, 1, 1);
    pvm_pkdouble(&final.virial_ratio, 1, 1);
    for (i = 0; i < 3; i++) {
	pvm_pkdouble(&final.system[i].mass, 1, 1);
	pvm_pkdouble(final.system[i].pos, 3, 1);
	pvm_pkdouble(final.system[i].vel, 3, 1);
	pvm_pkint(&final.system[i].index, 1, 1);
    }
}

void unpack(initial_state3 &init)
{
    pvm_upkdouble(&init.m2, 1, 1);
    pvm_upkdouble(&init.m2, 1, 1);
    pvm_upkdouble(&init.m3, 1, 1);
    pvm_upkdouble(&init.r1, 1, 1);
    pvm_upkdouble(&init.r2, 1, 1);
    pvm_upkdouble(&init.r3, 1, 1);
    pvm_upkdouble(&init.sma, 1, 1);
    pvm_upkdouble(&init.ecc, 1, 1);
    pvm_upkdouble(&init.v_inf, 1, 1);
    pvm_upkdouble(&init.rho, 1, 1);
    pvm_upkdouble(&init.r_init_min, 1, 1);
    pvm_upkdouble(&init.r_init_max, 1, 1);
    pvm_upkdouble(&init.r_init, 1, 1);
    pvm_upkdouble(&init.r_stop, 1, 1);
    pvm_upkdouble(&init.tidal_tol_factor, 1, 1);
    pvm_upkdouble(&init.phase.cos_theta, 1, 1);
    pvm_upkdouble(&init.phase.phi, 1, 1);
    pvm_upkdouble(&init.phase.psi, 1, 1);
    pvm_upkdouble(&init.phase.mean_anomaly, 1, 1);
    pvm_upkdouble(&init.eta, 1, 1);
    for (int i = 0; i < 3; i++) {
	pvm_upkdouble(&init.system[i].mass, 1, 1);
	pvm_upkdouble(init.system[i].pos, 3, 1);
	pvm_upkdouble(init.system[i].vel, 3, 1);
	pvm_upkint(&init.system[i].index, 1, 1);
    }
}

void unpack(intermediate_state3 &inter)
{
    pvm_upkint(&inter.n_osc, 1, 1);
    pvm_upkint(&inter.n_kepler, 1, 1);
    pvm_upkint(&inter.n_stars, 1, 1);
    pvm_upkint(inter.index, 3, 1);
    pvm_upkdouble(inter.r_min, 3, 1);
    pvm_upkdouble(&inter.r_min_min, 1,1);
    int i;
    pvm_upkint(&i, 1, 1);
    inter.descriptor = (intermediate_descriptor3)i;
    pvm_pkint(&i, 1, 1);

    for (i = 0; i < 3; i++) {
	pvm_upkdouble(&inter.system[i].mass, 1, 1);
	pvm_upkdouble(inter.system[i].pos, 3, 1);
	pvm_upkdouble(inter.system[i].vel, 3, 1);
	pvm_upkint(&inter.system[i].index, 1, 1);
    }
}

void unpack(final_state3 &final)
{
    pvm_upkdouble(&final.sma, 1, 1);
    pvm_upkdouble(&final.ecc, 1, 1);
    pvm_upkdouble(&final.outer_separation, 1, 1);
    int i;
    pvm_upkint(&i, 1, 1);
    final.descriptor = (final_descriptor3)i;
    pvm_upkint(&final.escaper, 1, 1);
    pvm_upkdouble(&final.error, 1, 1);
    pvm_upkdouble(&final.time, 1, 1);
    pvm_upkint(&final.n_steps, 1, 1);
    pvm_upkdouble(&final.virial_ratio, 1, 1);
    for (i = 0; i < 3; i++) {
	pvm_upkdouble(&final.system[i].mass, 1, 1);
	pvm_upkdouble(final.system[i].pos, 3, 1);
	pvm_upkdouble(final.system[i].vel, 3, 1);
	pvm_upkint(&final.system[i].index, 1, 1);
    }
}

#endif
