
       //=======================================================//    _\|/_
      //  __  _____           ___                    ___       //      /|\
     //  /      |      ^     |   \  |         ^     |   \     //          _\|/_
    //   \__    |     / \    |___/  |        / \    |___/    //            /|\
   //       \   |    /___\   |  \   |       /___\   |   \   // _\|/_
  //     ___/   |   /     \  |   \  |____  /     \  |___/  //   /|\     
 //                                                       //            _\|/_
//=======================================================//              /|\

// kira_diag:  Starlab kira/diag-specific functions.

#include "hdyn.h"

#ifndef TOOLBOX

bool kira_diag::check_diag(hdyn *b)
{
    // Acceptance criteria involve both system time and node label.
    // Only a single time range and label are allowed, for now.

    if (b->get_system_time() < t1 || b->get_system_time() > t2) return false;

    if (name && !clump_contains(b, name)) return false;
	
    return true;
}

#define PRS(x) s << "    " << #x << " = " << x << endl

void kira_diag::print(ostream &s)
{
    s << endl << "kira_diag settings:" << endl;

    PRS(kira_main);

    PRS(unpert_function_id);
    PRS(report_start_unperturbed);
    PRS(report_continue_unperturbed);
    PRS(report_end_unperturbed);
    PRS(report_pericenter_reflection);
    PRS(report_impending_multiple_status);
    PRS(report_zero_unpert_steps);
    PRS(report_multiple);
    PRS(unpert_report_level);
    PRS(end_unpert_report_level);
    PRS(multiple_report_level);

    PRS(tree);
    PRS(tree_level);

    PRS(ev_function_id);
    PRS(ev);
    PRS(harp);
    PRS(timestep_check);
    PRS(correct);
    PRS(slow_perturbed);

    PRS(kira_ev);

    PRS(slow);
    PRS(slow_level);

    PRS(report_stellar_evolution);
    PRS(report_stellar_mass_loss);
    PRS(report_binary_mass_loss);

    PRS(report_adjust_perturbed_list);

    PRS(report_correct_perturber_list);
}

#endif
